#include <math.h>
#include "overlay_resources.h"
#include "memory/arrays.h"


struct cats_2d_array_double *translate_resources(const struct cats_2d_array_double *data)
{
        struct cats_2d_array_double *result = new_2d_array_double(data->dimension);

        const cats_dt_coord rows = data->dimension.rows;
        const cats_dt_coord cols = data->dimension.cols;

        for (cats_dt_coord row = 0; row < rows; row++) {
                for (cats_dt_coord col = 0; col < cols; col++) {

                        double in_value = data->data[row][col];  // converter [translate_resources]
                        double out_value;

                        if (isnan(in_value)) {
                                out_value = 0.0;
                        } else {
                                if (in_value < 0 ) in_value = 0;
                                out_value = in_value;
                        }                        result->data[row][col] = out_value;  // converter [translate_resources]
                }
        }

        return result;
}
