#ifndef CATS_INLINE_BUTTERFLIES_H
#define CATS_INLINE_BUTTERFLIES_H

#include "butterflies_main.h"

static inline float butterflies_get_eggs(const struct grid_data_butterflies *data, cats_dt_coord row, cats_dt_coord col)
{       assert(data->eggs[row][col] >= 0);  // setter [butterflies_get_eggs]
        return data->eggs[row][col];        // setter [butterflies_get_eggs]
}

static inline void butterflies_set_eggs(struct grid_data_butterflies *data, cats_dt_coord row, cats_dt_coord col, float eggs)
{
        assert(eggs >= 0);
        data->eggs[row][col] = eggs; // setter [butterflies_set_eggs]
}

static inline void butterflies_add_eggs(struct grid_data_butterflies *data, cats_dt_coord row, cats_dt_coord col, float by)
{
        assert(by >= 0);
        data->eggs[row][col] += by; // setter [butterflies_add_eggs]
}

static inline void butterflies_remove_eggs(struct grid_data_butterflies *data, cats_dt_coord row, cats_dt_coord col, float by)
{
        assert(by >= 0);
        data->eggs[row][col] -= by;         // setter [butterflies_remove_eggs]
        assert(data->eggs[row][col] >= 0);  // setter [butterflies_remove_eggs]
}

static inline void butterflies_set_generations(struct grid_data_butterflies *data, cats_dt_coord row, cats_dt_coord col, float generations)
{
        assert(generations >= 0);                   // setter [butterflies_set_generations]
        data->generations[row][col] = generations;  // setter [butterflies_set_generations]
}

static inline float butterflies_get_generations(const struct grid_data_butterflies *data, cats_dt_coord row, cats_dt_coord col)
{
        return data->generations[row][col]; // getter [butterflies_get_generations]
}

static inline void butterflies_set_info_layer(struct grid_data_butterflies *data, cats_dt_coord row, cats_dt_coord col, int32_t value)
{
        data->info_layer[row][col] = value;  // setter [butterflies_set_info_layer]
}

static inline int32_t butterflies_get_info_layer(const struct grid_data_butterflies *data, cats_dt_coord row, cats_dt_coord col)
{
        return data->info_layer[row][col];  // getter [butterflies_get_info_layer]
}


#endif //CATS_INLINE_BUTTERFLIES_H
